/* --- The following code comes from C:\lcc\lib\wizard\textmode.tpl. */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "puzzles_raw.h"
#include "brieflz.h"






#define BLZ_WORKMEM_SIZE (1024*1024)







void Usage(char *programName)
{
	fprintf(stderr,"%s usage:\n",programName);
	/* Modify here to add your usage message when the program is
	 * called without arguments */
}

/* returns the index of the first argument that is not an option; i.e.
   does not start with a dash or a slash
*/
int HandleOptions(int argc,char *argv[])
{
	int i,firstnonoption=0;

	for (i=1; i< argc;i++) {
		if (argv[i][0] == '/' || argv[i][0] == '-') {
			switch (argv[i][1]) {
				/* An argument -? means help is requested */
				case '?':
					Usage(argv[0]);
					break;
				case 'h':
				case 'H':
					if (!stricmp(argv[i]+1,"help")) {
						Usage(argv[0]);
						break;
					}
					/* If the option -h means anything else
					 * in your application add code here
					 * Note: this falls through to the default
					 * to print an "unknow option" message
					*/
				/* add your option switches here */
				default:
					fprintf(stderr,"unknown option %s\n",argv[i]);
					break;
			}
		}
		else {
			firstnonoption = i;
			break;
		}
	}
	return firstnonoption;
}

int main(int argc,char *argv[])
{
	/*if (argc == 1) {
		// If no arguments we call the Usage routine and exit
		Usage(argv[0]);
		return 1;
	}
	// handle the program options
	HandleOptions(argc,argv);
	// The code of your application goes here
*/


	void* WMem = malloc(BLZ_WORKMEM_SIZE);
	unsigned char Buffer[400];

	FILE *Out;
	Out = fopen("puzzcom.h","w");

	fprintf(Out, "#ifndef __puzzcom__\n");
	fprintf(Out, "#define __puzzcom__\n");
	fprintf(Out, "\n\n\n");



	int Index[NrOfLevels*6];

	memset(Index,0,NrOfLevels*6*sizeof(int));
/*
	int C;

	//for(C=0;C<(NrOfLevels*6);C++){
	for(C=0;C<(NrOfLevels*6);C++){

		int Size = blz_pack(Puzzles+66*C,Buffer,66,WMem);
		Index[C] = Size;

		fprintf(Out, "#define Puzzle_%d_%d ",C/6+1,C%6+1);

		int D;
		for(D=0;D<Size;D++){

			fprintf(Out, "%u,",(unsigned char)Buffer[D]);



		};

		fprintf(Out, "\n\n\n");
	};






	fprintf(Out, "\n\n\n");

	fprintf(Out, "short Index[96]={\n");

	int Offset = 0;
	for(C=0;C<(NrOfLevels*6);C++){

		fprintf(Out, "%d,\n",Offset);
		//fprintf(Out, "%d,\n",Index[C]);
		Offset += Index[C];

	};*/




	int C;

	for(C=0;C<(NrOfLevels);C++){


		int Size = blz_pack(Puzzles+66*6*C,Buffer,66*6,WMem);
		Index[C] = Size;

		fprintf(Out, "#define Level_%d ",C+1);

		int D;
		for(D=0;D<Size;D++){

			fprintf(Out, "%u,",(unsigned char)Buffer[D]);



		};

		fprintf(Out, "\n\n\n");
	};

	fprintf(Out, "short Index[16]={\n");

	int Offset = 0;
	for(C=0;C<(NrOfLevels);C++){

		fprintf(Out, "%d,\n",Offset);
		//fprintf(Out, "%d,\n",Index[C]);
		Offset += Index[C];

	};



	fprintf(Out, "};");

	fprintf(Out, "\n\n\n");

	fprintf(Out, "// Total size: %d Compressed.\n\n\n" , Offset);

	fprintf(Out, "#endif");


	fclose(Out);


	free(WMem);

	return 0;
}
